<script setup lang="ts">
import { onMounted, ref } from 'vue'
import { useStockStore } from '@/stores/stock'
import { useRoute } from 'vue-router'
import { useOrderStore } from '@/stores/order'
import type { User } from '@/types/User'
import { useconvertPDFStore } from '@/stores/pdf'

const headers = [
    {
      title: 'Id',
      key: 'id'
    },
    {
      title: 'TotalPrice',
      key: 'total'
    },
    {
      title: 'Quantity',
      key: 'qty'
    },
    { 
      title: 'Date',
      key: 'created',
      value: (item: any) => {
            const createdDate = new Date(item.created);
            let orderDate = createdDate.toLocaleString('en-US', {
                weekday: 'long',
                hour12: false,
                hour: '2-digit',
                minute: '2-digit',
                second: '2-digit',
                day: '2-digit', 
                month: '2-digit', 
                year: 'numeric' 
            });
            return orderDate;
        }
    },
    {
      title: 'User',
      key: 'userId',
      value: (item: any | User) => item.user.fullName
    },
    { title: 'Prints', key: 'actions', sortable: false }
]

const route = useRoute()
const stockStore = useStockStore()
const orderStore = useOrderStore()
const pdfStore = useconvertPDFStore()

const search = ref('')
const nowName = ref('')
const selected = ref('Select Receipt')

onMounted(async () => {
  await orderStore.getOrders()
  await stockStore.getChecks()
  const strUser = localStorage.getItem('user')
  try {
    if (strUser) {
      const parsedUser = JSON.parse(strUser)
      nowName.value = parsedUser.fullName
    }
  } catch (error) {
    console.error('Error parsing user data:', error)
  }
})
</script>
<template>
  <v-toolbar flat color="#212121">
    <v-toolbar-title>History Stock</v-toolbar-title>
    <v-spacer></v-spacer>

    <v-text-field
      v-model="search"
      prepend-inner-icon="mdi-magnify"
      density="compact"
      label="Search"
      single-line
      flat
      hide-details
      variant="solo-filled"
      style="width: 1px"
    ></v-text-field>

    <!-- Put Dialog -->
    <v-menu transition="slide-y-transition">
      <template v-slot:activator="{ props }">
        <v-btn v-bind="props" icon>
          <v-icon>mdi-dots-vertical</v-icon>
        </v-btn>
      </template>
      <v-list>
        <v-list-item>
          <v-list-item-title>
            <v-btn
              block
              active-color="deep-orange-darken-4"
              link
              title="Stock"
              :class="{ active: route.name === 'stock' }"
              :to="{ path: '/Stock' }"
              rounded="0"
              elevation="0"
              style="display: flex; justify-content: flex-start; align-items: left;"
              >
              <v-icon size="25">mdi-package-variant-closed</v-icon>
              Stock
            </v-btn>
          </v-list-item-title>
          <v-list-item-title>
            <v-btn
              active-color="deep-orange-darken-4"
              link
              title="CheckStock"
              :class="{ active: route.name === 'checkstock' }"
              :to="{ path: '/CheckStock' }"
              rounded="0"
              elevation="0"
              block
              style="display: flex; justify-content: flex-start; align-items: left;"
              >
              <v-icon size="25">mdi-package-check</v-icon>
              CheckStock
            </v-btn>
          </v-list-item-title>
          <v-list-item-title>
            <v-btn
              active-color="deep-orange-darken-4"
              link
              title="OrderStock"
              :class="{ active: route.name === 'orderstock' }"
              :to="{ path: '/OrderStock' }"
              rounded="0"
              elevation="0"
              block
              style="display: flex; justify-content: flex-start; align-items: left;"
              >
              <v-icon size="25">mdi-truck-delivery</v-icon>
              OrderStock
            </v-btn>
          </v-list-item-title>
        </v-list-item>
      </v-list>
    </v-menu>
  </v-toolbar>
  <!-- ComboBox -->
    <v-row style="background-color: #282828;">
      <v-col></v-col>
      <v-col></v-col>
      <v-col></v-col>
      <v-col></v-col>
      <v-col>
        <v-combobox 
          :items="['Check Receipts', 'Order Receipts']"
          v-model="selected"
          variant="solo-filled"
          color="#a8a8a8"
          style="margin-top: 12px; margin-right: 12px;" 
          >
        </v-combobox>
      </v-col>
    </v-row>

  <div v-if="selected === 'Check Receipts'">
    <v-data-table v-model:search="search" :headers="headers" :items="stockStore.checkList">
      <template v-slot:top> </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="pdfStore.printCheckPDF(item)"> mdi-printer </v-icon>
      </template>
    </v-data-table>
  </div>

  <div v-if="selected === 'Order Receipts'">
    <v-data-table v-model:search="search" :headers="headers" :items="orderStore.orderList">
      <template v-slot:top> </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="pdfStore.printOrderPDF(item)"> mdi-printer </v-icon>
      </template>
    </v-data-table>
  </div>

    <!-- Dialog Confirm -->
    <v-dialog v-model="stockStore.dialogConfirm" max-width="500px">
      <v-card>
        <v-card-title class="text-h5" style="text-align: center">Confirm?</v-card-title>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="primary" variant="text" @click="stockStore.closeDialogCon()">Cancel</v-btn>
          <v-btn color="primary" variant="text" @click="stockStore.addUnit(stockStore.initialCheck)">OK</v-btn>
          <v-spacer></v-spacer>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- Dialog Reject-->
    <v-dialog v-model="stockStore.dialogReject" max-width="500px">
      <v-card>
        <v-card-title class="text-h5" style="text-align: center">
          <v-icon icon="mdi-alert" density="compact" size="small"></v-icon>Material
          Invaid.</v-card-title
        >
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="primary" variant="text" @click="stockStore.close()">OK</v-btn>
          <v-spacer></v-spacer>
        </v-card-actions>
      </v-card>
    </v-dialog>
</template>

